<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { useOrderStore } from '@/stores/Order'
import type { Order } from '@/types/Order'


const OrderStore = useOrderStore()

const OrderHistory = ref(OrderStore.Order)
const dialog = ref(false)
const selectedOrder = ref(null)

const orderHeaders = [
  { title: 'ID', value: 'id' },
  { title: 'Date', value: 'Date' },
  { title: 'Amount', value: 'Amount' },
  { title: 'Total Price', value: 'Total_price' },
  { title: 'Vendor', value: 'Vendor' },
  { title: 'Actions', value: 'actions', sortable: false }
]

const initialOrder: Order = {
  id: 0,
  Date: '',
  Amount: 0,
  Total_price: 0,
  Vendor: ''
}

function initializeOrderHistory() {
  OrderHistory.value = OrderStore.Order
}

onMounted(() => {
  initializeOrderHistory()
})

function showDetails(item: Order) {
  selectedOrder.value = item
  dialog.value = true
}

const confirmDeleteOrder = (item: Order) => {
  if (window.confirm('Are you sure you want to delete this Order?')) {
    deleteReceipt(item);
  }
};

function addOrderIngredient() {
  console.log('Adding new order ingredient');
}

</script>

<template>
  <div>
    <v-data-table :headers="orderHeaders" :items="OrderHistory"
      style="background-color: rgba(202, 174, 123, 0.582);">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgba(82, 72, 54, 0.842);">
          <v-toolbar-title style="color: rgb(255, 255, 255)"> Order Ingredient </v-toolbar-title>
          <v-divider class="mx-4" inset vertical color="blue darken-2"></v-divider>
          <v-btn color="white" v-bind="props" variant="outlined" style="margin-top: 2px; margin-left: 50px">
                            <v-icon style="margin-right: 8px;">mdi-package-variant-plus</v-icon>Add New Order
                        </v-btn>
        </v-toolbar>
      </template>
      <template v-slot:item="{ item }">
        <tr>
          <td>{{ item.id }}</td>
          <td>{{ item.Date }}</td>
          <td>{{ item.Amount }}</td>
          <td>{{ item.Total_price }}</td>
          <td>{{ item.Vendor }}</td>
          <td>
            <v-icon @click="showDetails(item)" style="cursor: pointer">mdi-eye</v-icon>
            <v-icon style="margin-left: 3px" @click="confirmDeleteOrder(item)">mdi-delete</v-icon>
          </td>
        </tr>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initializeOrderHistory">Reset</v-btn>
      </template>
    </v-data-table>

    <v-dialog v-model="dialog" max-width="800">
      <v-card>
        <v-card-title>Order Details</v-card-title>
        <v-card-text>
          <div v-if="selectedOrder">
            <p>ID: {{ selectedOrder.id }}</p>
            <p>Date: {{ selectedOrder.Date }}</p>
            <p>Amount: {{ selectedOrder.Amount }}</p>
            <p>Total Price: {{ selectedOrder.Total_price }}</p>
            <p>Vendor: {{ selectedOrder.Vendor }}</p>
            <p>Order products from Makro </p>
          </div>
        </v-card-text>
        <v-card-actions>
          <v-btn color="red" @click="dialog = false">Close</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
